﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Telerik.Windows;
using System.IO;
using Telerik.Windows.Controls;

namespace Example.Web
{
	/// <summary>
	/// Summary description for SampleUploadHandler
	/// </summary>
	public class SampleUploadHandler : RadUploadHandler
	{
		bool authorized = false;
		string accountName = string.Empty;

		public override bool SaveChunkData(string filePath, long position, byte[] buffer, int contentLength, out int savedBytes)
		{
			bool result;
			this.PrepareAccountSession();

			if (!this.PrepareStorageFolder())
			{
				result = false;
			}
			
			string FilePath = this.GetFilePath();
			result = base.SaveChunkData(FilePath, position, buffer, contentLength, out savedBytes);

			return result;
		}
		public override string GetTargetFolder()
		{
			string path = base.GetTargetFolder();
			if (!string.IsNullOrEmpty(this.accountName))
			{
				path += Path.DirectorySeparatorChar + this.accountName;
			}
			return path;
		}
		internal void PrepareAccountSession()
		{
			string dataAuthorized = this.GetQueryParameter("Authorized");
			this.authorized = !string.IsNullOrEmpty(dataAuthorized)
				&& dataAuthorized.ToLower() == "true";

			this.accountName = this.GetQueryParameter("Account");
			if (!this.authorized || string.IsNullOrEmpty(this.accountName))
				this.accountName = "Anonymous";
		}

		internal bool PrepareStorageFolder()
		{
			string folderPath = this.GetTargetFolder();
			if (!Directory.Exists(folderPath))
			{
				Directory.CreateDirectory(folderPath);
			}
			return Directory.Exists(folderPath);
		}
	}
}